/***************************************************************************
 *   Copyright (C) 2004 by Richard Moore                                   *
 *   rich@kde.org                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.             *
 ***************************************************************************/

#ifndef TQTSTUBS_H
#define TQTSTUBS_H
#include "global.h"
#ifdef QT_ONLY

#include <tqobject.h>
#include <tqurl.h>

class TQWidget;

typedef TQUrl KURL;

namespace KParts {

class KJSEMBED_EXPORT ReadOnlyPart : public TQObject
{
   TQ_OBJECT

public:
   ReadOnlyPart( TQObject *parent, const char *name=0 );
   virtual ~ReadOnlyPart();

   void setWidget( TQWidget *w ) { m_widget = w; }

private:
   TQWidget *m_widget;
};

class KJSEMBED_EXPORT ReadWritePart : public ReadOnlyPart
{
   TQ_OBJECT

public:
   ReadWritePart( TQObject *parent, const char *name=0 );
   virtual ~ReadWritePart();
};

} // namespace KParts

namespace KJSEmbed {

class KJSEMBED_EXPORT XMLActionClientStub
{
public:
   XMLActionClientStub() {}
   ~XMLActionClientStub() {}
};

typedef XMLActionClientStub XMLActionClient;

} // namespace KJSEmbed

#endif // QT_ONLY

#endif // TQTSTUBS_H
