// eventhandling.cs - qt-sharp Hello World
//
// Author: Adam Treat <manyoso@yahoo.com>
//
// (c) 2002 Adam Treat
//
// Licensed under the terms of the GNU GPL

namespace QtSamples {

	using Qt;
 	using System;

	public class EventHandling : TQVBox {

		public static void Main (String[] args)
		{
			TQApplication app = new TQApplication (args);
			EventHandling evh = new EventHandling ();
			app.SetMainWidget (evh);
			evh.Show ();
			app.Exec ();
		}

		public EventHandling () : base (null)
		{
			// This is the global event handler for TQMouseEvents
			mouseHandler += new TQMouseHandler(mouseEvents);

			MyButton pb = new MyButton (this);
		}

		public void mouseEvents (TQObject sender, TQEventArgs e)
		{
			Console.WriteLine ("Mouse event: " + e.Name);
		}

		class MyButton : TQPushButton {

			public MyButton (TQWidget parent) : base ("Hello Qt-Sharp-0.7!", parent)
			{
				// This is the local event handler for mousePressEvents
				mousePressEvent += new MousePressEvent (pressEvent);
			}

			public void pressEvent (TQMouseEvent e)
			{
				Console.WriteLine ("I've been clicked");
			}
		}
	}
}
