//Auto-generated by kalyptus. DO NOT EDIT.
package org.trinitydesktop.koala;

import org.trinitydesktop.qt.TQMetaObject;
import org.trinitydesktop.qt.QtSupport;
import org.trinitydesktop.qt.TQObject;
import org.trinitydesktop.qt.TQDataStream;
import org.trinitydesktop.qt.TQPoint;
import java.util.ArrayList;

public interface BrowserExtensionSignals {
	/**
		 Enables or disable a standard action held by the browser.
			 See class documentation for the list of standard actions.
		   		@short    Enables or disable a standard action held by the browser.
	*/
	void enableAction(String name, boolean enabled);
	/**
		 Change the text of a standard action held by the browser.
		 This can be used to change "Paste" into "Paste Image" for instance.
			 See class documentation for the list of standard actions.
				@short    Change the text of a standard action held by the browser.
	*/
	void setActionText(String name, String text);
	/**
		 Asks the host (browser) to open <code>url.</code>
		 To set a reload, the x and y offsets, the service type etc., fill in the
		 appropriate fields in the <code>args</code> structure.
		 Hosts should not connect to this signal but to openURLRequestDelayed.
		   		@short    Asks the host (browser) to open <code>url.</code>
	*/
	void openURLRequest(KURL url, URLArgs args);
	/**
		 Asks the host (browser) to open <code>url.</code>
		 To set a reload, the x and y offsets, the service type etc., fill in the
		 appropriate fields in the <code>args</code> structure.
		 Hosts should not connect to this signal but to openURLRequestDelayed.
		   		@short    Asks the host (browser) to open <code>url.</code>
	*/
	void openURLRequest(KURL url);
	/**
		 This signal is emitted when openURLRequest is called, after a 0-seconds timer.
		 This allows the caller to terminate what it's doing first, before (usually)
		 being destroyed. Parts should never use this signal, hosts should only connect
		 to this signal.
		   		@short    This signal is emitted when openURLRequest is called, after a 0-seconds timer.
	*/
	void openURLRequestDelayed(KURL url, URLArgs args);
	/**
		 This signal is emitted when openURLRequest is called, after a 0-seconds timer.
		 This allows the caller to terminate what it's doing first, before (usually)
		 being destroyed. Parts should never use this signal, hosts should only connect
		 to this signal.
		   		@short    This signal is emitted when openURLRequest is called, after a 0-seconds timer.
	*/
	void openURLRequestDelayed(KURL url);
	/**
		 Tells the hosting browser that the part opened a new URL (which can be
		 queried via KParts.Part.url().
			 This helps the browser to update/create an entry in the history.
		 The part may <b>not</b> emit this signal together with openURLRequest().
		 Emit openURLRequest() if you want the browser to handle a URL the user
		 asked to open (from within your part/document). This signal however is
		 useful if you want to handle URLs all yourself internally, while still
		 telling the hosting browser about new opened URLs, in order to provide
		 a proper history functionality to the user.
		 An example of usage is a html rendering component which wants to emit
		 this signal when a child frame document changed its URL.
		 Conclusion: you probably want to use openURLRequest() instead.
		   		@short    Tells the hosting browser that the part opened a new URL (which can be  queried via KParts.Part.url().
	*/
	void openURLNotify();
	/**
		 Updates the URL shown in the browser's location bar to <code>url.</code>
		   		@short    Updates the URL shown in the browser's location bar to <code>url.</code>
	*/
	void setLocationBarURL(String url);
	/**
		 Sets the URL of an icon for the currently displayed page.
		   		@short    Sets the URL of an icon for the currently displayed page.
	*/
	void setIconURL(KURL url);
	/**
		 Asks the hosting browser to open a new window for the given <code>url.</code>
			 The <code>args</code> argument is optional additional information for the
		 browser,
				@short    Asks the hosting browser to open a new window for the given <code>url.</code>
		@see URLArgs
	*/
	void createNewWindow(KURL url, URLArgs args);
	/**
		 Asks the hosting browser to open a new window for the given <code>url.</code>
			 The <code>args</code> argument is optional additional information for the
		 browser,
				@short    Asks the hosting browser to open a new window for the given <code>url.</code>
		@see URLArgs
	*/
	void createNewWindow(KURL url);
	// void createNewWindow(const KURL& arg1,const KParts::URLArgs& arg2,const KParts::WindowArgs& arg3,KParts::ReadOnlyPart*& arg4); >>>> NOT CONVERTED
	/**
		 Since the part emits the jobid in the started() signal,
		 progress information is automatically displayed.
			 However, if you don't use a TDEIO.Job in the part,
		 you can use loadingProgress() and speedProgress()
		 to display progress information.
		   		@short    Since the part emits the jobid in the started() signal,  progress information is automatically displayed.
	*/
	void loadingProgress(int percent);
	/**
				@short
		@see #loadingProgress
	*/
	void speedProgress(int bytesPerSecond);
	void infoMessage(String arg1);
	/**
		 Emit this to make the browser show a standard popup menu
		 at the point <code>global</code> for the files <code>items.</code>
		   		@short    Emit this to make the browser show a standard popup menu  at the point <code>global</code> for the files <code>items.</code>
	*/
	void popupMenu(TQPoint global, ArrayList items);
	/**
		 Emit this to make the browser show a standard popup menu
		 at the point <code>global</code> for the files <code>items.</code>
			 The GUI described by <code>client</code> is being merged with the popupmenu of the host
		   		@short    Emit this to make the browser show a standard popup menu  at the point <code>global</code> for the files <code>items.</code>
	*/
	void popupMenu(KXMLGUIClientInterface client, TQPoint global, ArrayList items);
	// void popupMenu(KXMLGUIClient* arg1,const TQPoint& arg2,const KFileItemList& arg3,const KParts::URLArgs& arg4,KParts::BrowserExtension::PopupFlags arg5); >>>> NOT CONVERTED
	/**
		 Emit this to make the browser show a standard popup menu
		 at the point <code>global</code> for the given <code>url.</code>
			 Give as much information
		 about this URL as possible, like the <code>mimeType</code> and the file type
		 (<code>mode</code>: S_IFREG, S_IFDIR...)
		   		@short    Emit this to make the browser show a standard popup menu  at the point <code>global</code> for the given <code>url.</code>
	*/
	void popupMenu(TQPoint global, KURL url, String mimeType, long mode);
	/**
		 Emit this to make the browser show a standard popup menu
		 at the point <code>global</code> for the given <code>url.</code>
			 Give as much information
		 about this URL as possible, like the <code>mimeType</code> and the file type
		 (<code>mode</code>: S_IFREG, S_IFDIR...)
		   		@short    Emit this to make the browser show a standard popup menu  at the point <code>global</code> for the given <code>url.</code>
	*/
	void popupMenu(TQPoint global, KURL url, String mimeType);
	/**
		 Emit this to make the browser show a standard popup menu
		 at the point <code>global</code> for the given <code>url.</code>
			 Give as much information
		 about this URL as possible, like the <code>mimeType</code> and the file type
		 (<code>mode</code>: S_IFREG, S_IFDIR...)
		 The GUI described by <code>client</code> is being merged with the popupmenu of the host
		   		@short    Emit this to make the browser show a standard popup menu  at the point <code>global</code> for the given <code>url.</code>
	*/
	void popupMenu(KXMLGUIClientInterface client, TQPoint global, KURL url, String mimeType, long mode);
	/**
		 Emit this to make the browser show a standard popup menu
		 at the point <code>global</code> for the given <code>url.</code>
			 Give as much information
		 about this URL as possible, like the <code>mimeType</code> and the file type
		 (<code>mode</code>: S_IFREG, S_IFDIR...)
		 The GUI described by <code>client</code> is being merged with the popupmenu of the host
		   		@short    Emit this to make the browser show a standard popup menu  at the point <code>global</code> for the given <code>url.</code>
	*/
	void popupMenu(KXMLGUIClientInterface client, TQPoint global, KURL url, String mimeType);
	// void popupMenu(KXMLGUIClient* arg1,const TQPoint& arg2,const KURL& arg3,const KParts::URLArgs& arg4,KParts::BrowserExtension::PopupFlags arg5,mode_t arg6); >>>> NOT CONVERTED
	// void popupMenu(KXMLGUIClient* arg1,const TQPoint& arg2,const KURL& arg3,const KParts::URLArgs& arg4,KParts::BrowserExtension::PopupFlags arg5); >>>> NOT CONVERTED
	/**
		 Inform the hosting application about the current selection.
		 Used when a set of files/URLs is selected (with full information
		 about those URLs, including size, permissions etc.)
		   		@short    Inform the hosting application about the current selection.
	*/
	void selectionInfo(ArrayList items);
	/**
		 Inform the hosting application about the current selection.
		 Used when some text is selected.
		   		@short    Inform the hosting application about the current selection.
	*/
	void selectionInfo(String text);
	/**
		 Inform the hosting application that the user moved the mouse over an item.
		 Used when the mouse is on an URL.
		   		@short    Inform the hosting application that the user moved the mouse over an item.
	*/
	void mouseOverInfo(KFileItem item);
	/**
		 Ask the hosting application to add a new HTML (aka Mozilla/Netscape)
		 SideBar entry.
		   		@short    Ask the hosting application to add a new HTML (aka Mozilla/Netscape)  SideBar entry.
	*/
	void addWebSideBar(KURL url, String name);
	/**
		 Ask the hosting application to move the top level widget.
		   		@short    Ask the hosting application to move the top level widget.
	*/
	void moveTopLevelWidget(int x, int y);
	/**
		 Ask the hosting application to resize the top level widget.
		   		@short    Ask the hosting application to resize the top level widget.
	*/
	void resizeTopLevelWidget(int w, int h);
	/**
		 Ask the hosting application to focus <code>part.</code>
				@short    Ask the hosting application to focus <code>part.</code>
	*/
	void requestFocus(ReadOnlyPart part);
	/**
		 Tell the host (browser) about security state of current page
		 enum PageSecurity { NotCrypted, Encrypted, Mixed }
				@short    Tell the host (browser) about security state of current page  enum PageSecurity { NotCrypted, Encrypted, Mixed }
	*/
	void setPageSecurity(int arg1);
}
