//Auto-generated by kalyptus. DO NOT EDIT.
package org.trinitydesktop.koala;

import org.trinitydesktop.qt.Qt;
import org.trinitydesktop.qt.TQMetaObject;
import org.trinitydesktop.qt.QtSupport;
import org.trinitydesktop.qt.TQObject;
import org.trinitydesktop.qt.TQObject;

/**

 Basic class to manage a history of "items". This class is only meant
 for fast lookup, if an item is in the history or not.
 May be subclassed to implement a persistent history for example.
 For usage with tdehtml, just create your provider and call the
 HistoryProvider constructor _before_ you do any tdehtml stuff. That way,
 tdehtml, using the self()-method, will use your subclassed provider.
 See {@link HistoryProviderSignals} for signals emitted by HistoryProvider
		@author Carsten Pfeiffer <pfeiffer@kde.org>

		@short    Basic class to manage a history of "items".

*/
public class HistoryProvider extends TQObject  {
	protected HistoryProvider(Class dummy){super((Class) null);}
	public native TQMetaObject metaObject();
	public native String className();
	/**
		 Creates a KHistoryProvider with an optional parent and name
		     		@short    Creates a KHistoryProvider with an optional parent and name
	*/
	public HistoryProvider(TQObject parent, String name) {
		super((Class) null);
		newHistoryProvider(parent,name);
	}
	private native void newHistoryProvider(TQObject parent, String name);
	public HistoryProvider(TQObject parent) {
		super((Class) null);
		newHistoryProvider(parent);
	}
	private native void newHistoryProvider(TQObject parent);
	public HistoryProvider() {
		super((Class) null);
		newHistoryProvider();
	}
	private native void newHistoryProvider();
	/**
				@return true if <code>item</code> is present in the history.

		@short
	*/
	public native boolean contains(String item);
	/**
		 Inserts <code>item</code> into the history.
		     		@short    Inserts <code>item</code> into the history.
	*/
	public native void insert(String item);
	/**
		 Removes <code>item</code> from the history.
		     		@short    Removes <code>item</code> from the history.
	*/
	public native void remove(String item);
	/**
		 Clears the history. The cleared() signal is emitted after clearing.
		     		@short    Clears the history.
	*/
	public native void clear();
	public static native HistoryProvider self();
}
