//Auto-generated by kalyptus. DO NOT EDIT.
package org.trinitydesktop.koala;

import org.trinitydesktop.qt.Qt;
import org.trinitydesktop.qt.QtSupport;

/**

 The KDCOPActionProxy class provides an easy way to publish a collection of TDEAction objects
 through DCOP. For the DCOP client the exported actions behave like full-fledged DCOP objects,
 providing full access to the TDEAction object functionality in the server.
 This class can generate DCOP object ids for given action objects, which it automatically
 processes, as being a DCOPObjectProxy .
 		@short A proxy class publishing a DCOP interface for actions.

*/
public class KDCOPActionProxy extends DCOPObjectProxy  {
	protected KDCOPActionProxy(Class dummy){super((Class) null);}
	/**
		 Constructs a dcop action proxy, being able to export the actions of the provided
		 TDEActionCollection through DCOP, using the parent DCOPObject's object id to
		 generate unique object ids for the actions.
		   		@short    Constructs a dcop action proxy, being able to export the actions of the provided  TDEActionCollection through DCOP, using the parent DCOPObject's object id to  generate unique object ids for the actions.
	*/
	public KDCOPActionProxy(TDEActionCollection actionCollection, DCOPObjectInterface parent) {
		super((Class) null);
		newKDCOPActionProxy(actionCollection,parent);
	}
	private native void newKDCOPActionProxy(TDEActionCollection actionCollection, DCOPObjectInterface parent);
	/**
		 Use this constructor if do not want to provide the exportable actions through a
		 TDEActionCollection . You have to reimplement the actions() and
		 action() methods if you use this constructor.
		   		@short    Use this constructor if do not want to provide the exportable actions through a  TDEActionCollection .
	*/
	public KDCOPActionProxy(DCOPObjectInterface parent) {
		super((Class) null);
		newKDCOPActionProxy(parent);
	}
	private native void newKDCOPActionProxy(DCOPObjectInterface parent);
	/**
		 Returns an action object with the given name. The default implementation queries the action object
		 from the TDEActionCollection, if the first constructor has been used.
		   		@short    Returns an action object with the given name.
	*/
	public native TDEAction action(String name);
	/**
		 Use this method to retrieve a DCOP object id for an action with the given name.
		 This class automatically takes care of processing DCOP object requests for the returned
		 object id.
			 You can construct a global DCOP object referenence using DCOPRef. For example like
		 DCOPRef( kapp.dcopClient().appId, actionProxy.actionObjectId( actionName ) );
			 The action with the given name has to be available through the #action method.
		   		@short    Use this method to retrieve a DCOP object id for an action with the given name.
	*/
	public native String actionObjectId(String name);
	/**
		 Returns a map of all exported actions, with the action name as keys and a global DCOP reference
		 as data entries.
		 The appId argument is used to specify the appid component of the DCOP reference. By default the
		 global application id is used ( kapp.dcopClient().appId() ) .
		   		@short    Returns a map of all exported actions, with the action name as keys and a global DCOP reference  as data entries.
	*/
	// TQMap<TQCString, DCOPRef> actionMap(const TQCString& arg1); >>>> NOT CONVERTED
	// TQMap<TQCString, DCOPRef> actionMap(); >>>> NOT CONVERTED
	/**
		 Internal reimplementation of DCOPObjectProxy.process .
		   		@short    Internal reimplementation of DCOPObjectProxy.process .
	*/
	public native boolean process(String arg1, String fun, byte[] data, StringBuffer replyType, byte[] replyData);
	/**
		 Called by the #process method and takes care of processing the object request for an
		 action object.
		   		@short    Called by the #process method and takes care of processing the object request for an  action object.
	*/
	public native boolean processAction(String arg1, String fun, byte[] data, StringBuffer replyType, byte[] replyData, TDEAction action);
	/** Deletes the wrapped C++ instance */
	protected native void finalize() throws InternalError;
	/** Delete the wrapped C++ instance ahead of finalize() */
	public native void dispose();
	/** Has the wrapped C++ instance been deleted? */
	public native boolean isDisposed();
}
