//Auto-generated by kalyptus. DO NOT EDIT.
package org.trinitydesktop.koala;

import org.trinitydesktop.qt.Qt;
import org.trinitydesktop.qt.QtSupport;

/**

 <code>TreeWalker</code> objects are used to navigate a document
 tree or subtree using the view of the document defined by its
 <code>whatToShow</code> flags and any filters that are defined
 for the <code>TreeWalker</code> . Any function which performs
 navigation using a <code>TreeWalker</code> will automatically
 support any view defined by a <code>TreeWalker</code> .
  Omitting nodes from the logical view of a subtree can result in a
 structure that is substantially different from the same subtree in
 the complete, unfiltered document. Nodes that are siblings in the
 TreeWalker view may be children of different, widely separated
 nodes in the original view. For instance, consider a Filter that
 skips all nodes except for Text nodes and the root node of a
 document. In the logical view that results, all text nodes will be
 siblings and appear as direct children of the root node, no matter
 how deeply nested the structure of the original document.
 		@short    <code>TreeWalker</code> objects are used to navigate a document  tree or subtree using the view of the document defined by its  <code>whatToShow</code> flags and any filters that are defined  for the <code>TreeWalker</code> .

*/
public class TreeWalker implements QtSupport {
	private long _qt;
	private boolean _allocatedInJavaWorld = true;
	protected TreeWalker(Class dummy){}

	public TreeWalker() {
		newTreeWalker();
	}
	private native void newTreeWalker();
	public TreeWalker(TreeWalker other) {
		newTreeWalker(other);
	}
	private native void newTreeWalker(TreeWalker other);
	/**
		 The root node of the TreeWalker, as specified when it was created.
		     		@short    The root node of the TreeWalker, as specified when it was created.
	*/
	public native Node root();
	/**
		 This attribute determines which node types are presented via the
		 TreeWalker. The available set of constants is defined in the NodeFilter
		 interface. Nodes not accepted by whatToShow will be skipped, but their
		 children may still be considered. Note that this skip takes precedence
		 over the filter, if any.
		     		@short    This attribute determines which node types are presented via the  TreeWalker.
	*/
	public native long whatToShow();
	/**
		 The filter used to screen nodes.
		     		@short    The filter used to screen nodes.
	*/
	public native NodeFilter filter();
	/**
		 The value of this flag determines whether the children of entity
		 reference nodes are visible to the TreeWalker. If false, they and their
		 descendents will be rejected. Note that this rejection takes precedence
		 over whatToShow and the filter, if any.
			 To produce a view of the document that has entity references expanded
		 and does not expose the entity reference node itself, use the whatToShow
		 flags to hide the entity reference node and set expandEntityReferences
		 to true when creating the TreeWalker. To produce a view of the document
		 that has entity reference nodes but no entity expansion, use the
		 whatToShow flags to show the entity reference node and set
		 expandEntityReferences to false.
		     		@short    The value of this flag determines whether the children of entity  reference nodes are visible to the TreeWalker.
	*/
	public native boolean expandEntityReferences();
	/**
		 The node at which the TreeWalker is currently positioned.
		 Alterations to the DOM tree may cause the current node to no longer be
		 accepted by the TreeWalker's associated filter. currentNode may also be
		 explicitly set to any node, whether or not it is within the subtree
		 specified by the root node or would be accepted by the filter and
		 whatToShow flags. Further traversal occurs relative to currentNode even
		 if it is not part of the current view, by applying the filters in the
		 requested direction; if no traversal is possible, currentNode is not changed.
				@short    The node at which the TreeWalker is currently positioned.
	*/
	public native Node currentNode();
	/**
		 see currentNode
		     		@short    see currentNode
	*/
	public native void setCurrentNode(Node _currentNode);
	/**
		 Moves to and returns the parent node of the current node. If
		 there is no parent node, or if the current node is the root
		 node from which this TreeWalker was created, retains the
		 current position and returns null.
			     		@return The new parent node, or null if the current node has no
 parent in the TreeWalker's logical view.

		@short    Moves to and returns the parent node of the current node.
	*/
	public native Node parentNode();
	/**
		 Moves the <code>TreeWalker</code> to the first child of the
		 current node, and returns the new node. If the current node has
		 no children, returns <code>null</code> , and retains the
		 current node.
			     		@return The new node, or <code>null</code> if the current
 node has no children.

		@short    Moves the <code>TreeWalker</code> to the first child of the  current node, and returns the new node.
	*/
	public native Node firstChild();
	/**
		 Moves the <code>TreeWalker</code> to the last child of the
		 current node, and returns the new node. If the current node has
		 no children, returns <code>null</code> , and retains the
		 current node.
			     		@return The new node, or <code>null</code> if the current
 node has no children.

		@short    Moves the <code>TreeWalker</code> to the last child of the  current node, and returns the new node.
	*/
	public native Node lastChild();
	/**
		 Moves the <code>TreeWalker</code> to the previous sibling of
		 the current node, and returns the new node. If the current node
		 has no previous sibling, returns <code>null</code> , and
		 retains the current node.
			     		@return The new node, or <code>null</code> if the current
 node has no previous sibling.

		@short    Moves the <code>TreeWalker</code> to the previous sibling of  the current node, and returns the new node.
	*/
	public native Node previousSibling();
	/**
		 Moves the <code>TreeWalker</code> to the next sibling of the
		 current node, and returns the new node. If the current node has
		 no next sibling, returns <code>null</code> , and retains the
		 current node.
			     		@return The new node, or <code>null</code> if the current
 node has no next sibling.

		@short    Moves the <code>TreeWalker</code> to the next sibling of the  current node, and returns the new node.
	*/
	public native Node nextSibling();
	/**
		 Moves the <code>TreeWalker</code> to the previous node in
		 document order relative to the current node, and returns the
		 new node. If the current node has no previous node, returns
		 <code>null</code> , and retains the current node.
			     		@return The new node, or <code>null</code> if the current
 node has no previous node.

		@short    Moves the <code>TreeWalker</code> to the previous node in  document order relative to the current node, and returns the  new node.
	*/
	public native Node previousNode();
	/**
		 Moves the <code>TreeWalker</code> to the next node in
		 document order relative to the current node, and returns the
		 new node. If the current node has no next node, returns
		 <code>null</code> , and retains the current node.
			     		@return The new node, or <code>null</code> if the current
 node has no next node.

		@short    Moves the <code>TreeWalker</code> to the next node in  document order relative to the current node, and returns the  new node.
	*/
	public native Node nextNode();
	/**
			 not part of the DOM
		     		@short
	*/
	// DOM::TreeWalkerImpl* handle(); >>>> NOT CONVERTED
	public native boolean isNull();
	// DOM::TreeWalker* TreeWalker(DOM::TreeWalkerImpl* arg1); >>>> NOT CONVERTED
}
